<html>
<head>
<title>OGRE: Ogre::StaticFaceGroup Struct Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="structOgre_1_1StaticFaceGroup.html">StaticFaceGroup</a></div>
<h1>Ogre::StaticFaceGroup Struct Reference</h1><!-- doxytag: class="Ogre::StaticFaceGroup" -->Collectes a group of static ie immovable faces together which have common properties like the material they use, the plane they lie on.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>&gt;</code>
<p>

<p>
<a href="structOgre_1_1StaticFaceGroup-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#7c11c8a17d7bbfc5aab6f982fb0d7f38">FaceGroupType</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#bc91f43284e36aa2376f4d54078f0480">fType</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#a58eb0dbf0fdf7e625c80e7dbb0e76f9">isSky</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Is this a sky surface?  <a href="#a58eb0dbf0fdf7e625c80e7dbb0e76f9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#09215495af768e8a68b20cf1a937af3a">vertexStart</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Index into a buffer containing vertex definitions.  <a href="#09215495af768e8a68b20cf1a937af3a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#4b1e2bb83673099b9d2459a1bb67f429">numVertices</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The range of vertices in the buffer this facegroup references.  <a href="#4b1e2bb83673099b9d2459a1bb67f429"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#3f73219edf1201e9a3c769f9ccc672bf">elementStart</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Index into a buffer containing vertex indices.  <a href="#3f73219edf1201e9a3c769f9ccc672bf"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#2dba19f0f06565cd111206a4a673239c">numElements</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The number of vertex indices.  <a href="#2dba19f0f06565cd111206a4a673239c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#697d56998dccec97a4670930ea7c2a41">materialHandle</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Handle to material used by this group.  <a href="#697d56998dccec97a4670930ea7c2a41"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Plane.html">Plane</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#d258e1806394cbd8b2efe7f39d3a7296">plane</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1PatchSurface.html">PatchSurface</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#42cad07e5dea1a57a10304dcd7b7810b">patchSurf</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Patch surface (only applicable when fType = FGT_PATCH).  <a href="#42cad07e5dea1a57a10304dcd7b7810b"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Friends</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">_OgreExport friend <br>
std::ostream &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#e57aba80895c22bb02f633d02be64edb">operator&lt;&lt;</a> (std::ostream &amp;o, const <a class="el" href="structOgre_1_1StaticFaceGroup.html">StaticFaceGroup</a> &amp;s)</td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Collectes a group of static ie immovable faces together which have common properties like the material they use, the plane they lie on. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Whilst for discrete geometry (i.e. movable objects) groups of faces are held in the <a class="el" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> class, for immovable objects like scenery there needs to ba little more flexibility in the grouping since the group is likely to be a small part of a huge set of geometry. In addition, because the faces are unmoving certain optimisations can be performed, e.g. precalculating a world-coordinate bounding box and normal. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Exactly how this class is used depends on the format of the large static geometry used in the level. An example would be the use of this class in the BspNode class for indoor levels. For flexibility and efficiency, it is not assumed that this class holds details of the vertices itself, or in fact that it holds the vertex indices itself. Everything is manipulated via pointers so if you want this class to point into a block of geometry data it can. </dd></dl>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h-source.html#l00064">64</a> of file <a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>.</p>
<hr><h2>Friends And Related Function Documentation</h2>
<a class="anchor" name="e57aba80895c22bb02f633d02be64edb"></a><!-- doxytag: member="Ogre::StaticFaceGroup::operator&lt;&lt;" ref="e57aba80895c22bb02f633d02be64edb" args="(std::ostream &amp;o, const StaticFaceGroup &amp;s)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">_OgreExport friend std::ostream&amp; operator&lt;&lt;           </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&nbsp;</td>
          <td class="paramname"> <em>o</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1StaticFaceGroup.html">StaticFaceGroup</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>s</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h-source.html#l00108">108</a> of file <a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="bc91f43284e36aa2376f4d54078f0480"></a><!-- doxytag: member="Ogre::StaticFaceGroup::fType" ref="bc91f43284e36aa2376f4d54078f0480" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#7c11c8a17d7bbfc5aab6f982fb0d7f38">FaceGroupType</a> <a class="el" href="structOgre_1_1StaticFaceGroup.html#bc91f43284e36aa2376f4d54078f0480">Ogre::StaticFaceGroup::fType</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h-source.html#l00066">66</a> of file <a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="a58eb0dbf0fdf7e625c80e7dbb0e76f9"></a><!-- doxytag: member="Ogre::StaticFaceGroup::isSky" ref="a58eb0dbf0fdf7e625c80e7dbb0e76f9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="structOgre_1_1StaticFaceGroup.html#a58eb0dbf0fdf7e625c80e7dbb0e76f9">Ogre::StaticFaceGroup::isSky</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Is this a sky surface? 
<p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h-source.html#l00069">69</a> of file <a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="09215495af768e8a68b20cf1a937af3a"></a><!-- doxytag: member="Ogre::StaticFaceGroup::vertexStart" ref="09215495af768e8a68b20cf1a937af3a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structOgre_1_1StaticFaceGroup.html#09215495af768e8a68b20cf1a937af3a">Ogre::StaticFaceGroup::vertexStart</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Index into a buffer containing vertex definitions. 
<p>
Because we're dealing with subsets of large levels this is likely to be part-way through a huge vertex buffer. 
<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h-source.html#l00074">74</a> of file <a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="4b1e2bb83673099b9d2459a1bb67f429"></a><!-- doxytag: member="Ogre::StaticFaceGroup::numVertices" ref="4b1e2bb83673099b9d2459a1bb67f429" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structOgre_1_1StaticFaceGroup.html#4b1e2bb83673099b9d2459a1bb67f429">Ogre::StaticFaceGroup::numVertices</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The range of vertices in the buffer this facegroup references. 
<p>
This is really for copying purposes only, so that we know which subset of vertices to copy from our large-level buffer into the rendering buffer. 
<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h-source.html#l00080">80</a> of file <a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="3f73219edf1201e9a3c769f9ccc672bf"></a><!-- doxytag: member="Ogre::StaticFaceGroup::elementStart" ref="3f73219edf1201e9a3c769f9ccc672bf" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structOgre_1_1StaticFaceGroup.html#3f73219edf1201e9a3c769f9ccc672bf">Ogre::StaticFaceGroup::elementStart</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Index into a buffer containing vertex indices. 
<p>
This buffer may be individual to this group or shared for memory allocation efficiency.The vertex indexes are relative the the mVertexStart pointer, not to the start of the large-level buffer, allowing simple reindexing when copying data into rendering buffers. This is only applicable to FGT_FACE_LIST face group types. 
<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h-source.html#l00089">89</a> of file <a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2dba19f0f06565cd111206a4a673239c"></a><!-- doxytag: member="Ogre::StaticFaceGroup::numElements" ref="2dba19f0f06565cd111206a4a673239c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structOgre_1_1StaticFaceGroup.html#2dba19f0f06565cd111206a4a673239c">Ogre::StaticFaceGroup::numElements</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The number of vertex indices. 
<p>
This is only applicable to FGT_FACE_LIST face group types. 
<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h-source.html#l00094">94</a> of file <a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="697d56998dccec97a4670930ea7c2a41"></a><!-- doxytag: member="Ogre::StaticFaceGroup::materialHandle" ref="697d56998dccec97a4670930ea7c2a41" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structOgre_1_1StaticFaceGroup.html#697d56998dccec97a4670930ea7c2a41">Ogre::StaticFaceGroup::materialHandle</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Handle to material used by this group. 
<p>
Note the use of the material handle rather than the material name - this is for efficiency since there will be many of these. 
<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h-source.html#l00100">100</a> of file <a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="d258e1806394cbd8b2efe7f39d3a7296"></a><!-- doxytag: member="Ogre::StaticFaceGroup::plane" ref="d258e1806394cbd8b2efe7f39d3a7296" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html">Plane</a> <a class="el" href="structOgre_1_1StaticFaceGroup.html#d258e1806394cbd8b2efe7f39d3a7296">Ogre::StaticFaceGroup::plane</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h-source.html#l00102">102</a> of file <a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="42cad07e5dea1a57a10304dcd7b7810b"></a><!-- doxytag: member="Ogre::StaticFaceGroup::patchSurf" ref="42cad07e5dea1a57a10304dcd7b7810b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1PatchSurface.html">PatchSurface</a>* <a class="el" href="structOgre_1_1StaticFaceGroup.html#42cad07e5dea1a57a10304dcd7b7810b">Ogre::StaticFaceGroup::patchSurf</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Patch surface (only applicable when fType = FGT_PATCH). 
<p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h-source.html#l00105">105</a> of file <a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this struct was generated from the following file:<ul>
<li><a class="el" href="OgreStaticFaceGroup_8h-source.html">OgreStaticFaceGroup.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:54:02 2008
</p>
</body>
</html>
